<extorder>
    <style>
        input[name='paymentType'] {
            margin-left: -40px;
        }
        label[for*="DTE_Field_paymentType"] {
            margin-left: -30px !important;
        }
        td.assetId {
            text-decoration: underline;
            cursor: pointer;
        }
        #extorder-search-item {
            margin-top: 32px;
            margin-bottom: 12px;
            margin-right: 25px;
            display: flex;
        }
    </style>
    <div id="extorder-search-item" class="hide">
        <div id="extorder-search-asset-id">
            <label for="assetId">端末ID: </label>
            <input type="text" id="assetId" name="assetId" class="search_assetId" />
        </div>
    </div>
    <data/>
    <script>
        export default {
            onBeforeMount(props, state) {
                this.scrutiny = props.scrutiny
                this.logoutModal = props.logoutModal
            },
            onMounted(props, states) {
                RiotUtil.next("data", {
                    scrutiny: this.scrutiny,
                    logoutModal: this.logoutModal,
                    mapService: new MapService(),
                    title: "延長注文管理",
                    name: 'extorder',
                    order: [[1,"desc"]],
                    disabledColumns: [1,2,3,4,5,6,7,8,9,10,11,12],
                    items: ["No", "端末ID", "決済種類","決済ID", "決済金額", "決済前Ver.", "決済後Ver.", "決済前利用期間", "決済後利用期間", "ケースID", "延長時日時","備考"],
                    service: new ExtOrderService(),
                    leftButtons: [{
                        label: '検索',
                        onclick: function (e) {
                            $("#extorder_datatables").dataTable().api().ajax.reload()
                        }
                    }],
                    ajax: async function (handler) {
                        var assetId = $('#assetId').val()
                        var email = UserInfo.getInstance().getEmail()
                        var response = await this.service.search(email, assetId)
                        if (response.status != "OK" || !response.data || response.data.length < 1) {
                            return handler([])
                        }

                        var jsons = []
                        response.data.forEach(data => {

                            // 延長日時から30日以内
                            var json = {
                                extOrderNo: this.scrutiny(data.extOrderNo),
                                assetId: this.scrutiny(data.assetId),
                                paymentType: this.scrutiny(data.paymentType),
                                paymentId: this.scrutiny(data.paymentId),
                                amount: this.scrutiny(data.amount),
                                prevVersion: this.scrutiny(data.prevVersion),
                                afterVersion: this.scrutiny(data.afterVersion),
                                prevUsagePeriod: this.scrutiny(data.prevUsagePeriod),
                                afterUsagePeriod: this.scrutiny(data.afterUsagePeriod),
                                caseId: this.scrutiny(data.caseId),
                                updatedAt: data.updatedAt ? data.updatedAt: '',
                                memo: this.scrutiny(data.memo),
                                rowId: data.rowId ? data.rowId : Math.random()
                            }
                            jsons.push(json)
                        })
                        handler(jsons)
                    },
                    addJSON: function (json) {
                        json.columns.forEach(function (column) {
                            if (column.data == 'paymentType') {
                                column.render = function (data, type, row) {
                                    var code = Code.PAYMENT_TYPE.find(code => {
                                        return code.value == data
                                    })
                                    return code.label
                                }
                            }
                        })
                        return json
                    },
                    draw: function() {
                        $('td.assetId').off('click')
                        $('td.assetId').on('click', {mapService: this.mapService}, function (e) {
                            var assetId = $(this).parent().find('.assetId').text()
                            riot.unmount('commonmodal', {}, 'assetmodal')
                            var assetModal = riot.mount('commonmodal',{
                                assetId: assetId,
                                mapService: e.data.mapService
                            }, 'assetmodal')[0]
                            assetModal.show()
                        })
                    },
                    initComplete: function () {
                        $('#extorder-search-item').removeClass('hide')
                        $('admincontent #search-menu').prepend($('#extorder-search-item'))
                    }
                }, "datatables")
            }
        }
    </script>
</extorder>
